(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     33346,        875]
NotebookOptionsPosition[     32067,        846]
NotebookOutlinePosition[     32424,        862]
CellTagsIndexPosition[     32381,        859]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "\"\<\n\t\!\(\*SubscriptBox[OverscriptBox[\(a\), \(\[RightVector]\)], \
\(m\)]\)(n) \:4e3a\:884c\:661f\:56e0\:5176 n \:9636\:7403\:8c10\:573a\:4e0e\
\:5916\:90e8\:8d28\:70b9 m \:4f5c\:7528\:ff0c\:81ea\:8eab\:4ea7\:751f\:7684\
\:5f15\:529b\:52a0\:901f\:5ea6;\n\t\:6b64\:51fd\:6570\:8fd4\:56de\n\t\t\
\!\(\*SubscriptBox[OverscriptBox[\(a\), \(\[RightVector]\)], \(m\)]\)(n) / ( \
\!\(\*FractionBox[\(G\\\ m\\\ \*SuperscriptBox[\(R\), \(n\)]\), \
SuperscriptBox[\(r\), \(2 n + 3\)]]\) )\n\t\:8fd4\:56de\:503c\:4e2d\n\t\t\
j[n], c[n, m], s[n, m] \:5206\:522b\:4e3a\:884c\:661f\:7684 n \:9636\:7403\
\:8c10\:7cfb\:6570 \!\(\*SubscriptBox[\(J\), \(n\)]\), \!\(\*SubscriptBox[\(C\
\), \(nm\)]\), \!\(\*SubscriptBox[\(S\), \(nm\)]\);\n\t\t{x, y, z} \:4e3a\
\:8d28\:70b9 m \:5728\:884c\:661f\:81ea\:8f6c\:5750\:6807\:7cfb\:ff08\:5373\
\:7403\:8c10\:7cfb\:6570\:6240\:5728\:5750\:6807\:7cfb\:ff09\:4e2d\:76f8\:5bf9\
\:884c\:661f\:8d28\:5fc3\:ff08\:539f\:70b9\:ff09\:7684\:5750\:6807;\n\t\tr = \
\!\(\*SqrtBox[\(\*SuperscriptBox[\(x\), \(2\)] + \*SuperscriptBox[\(y\), \
\(2\)] + \*SuperscriptBox[\(z\), \(2\)]\)]\) \:4e3a\:8d28\:70b9\:4e0e\:884c\
\:661f\:7684\:4e2d\:5fc3\:8ddd\:79bb\:3002\[IndentingNewLine]\>\"", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"amH", "[", "n_", "]"}], ":=", 
     RowBox[{
      RowBox[{"amH", "[", "n", "]"}], "=", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "a", ",", "GM", ",", "r", ",", "R", ",", "phi", ",", "lambda", ",", 
          "ax", ",", "ay", ",", "az"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ax", ",", "ay", ",", "az"}], "}"}], "=", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "lambda", "]"}], 
               RowBox[{"Cos", "[", "phi", "]"}]}], ",", 
              RowBox[{
               RowBox[{"Sin", "[", "lambda", "]"}], 
               RowBox[{"Cos", "[", "phi", "]"}]}], ",", 
              RowBox[{"Sin", "[", "phi", "]"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Cos", "[", "lambda", "]"}], 
               RowBox[{"Cos", "[", 
                RowBox[{"phi", "+", 
                 RowBox[{"Pi", "/", "2"}]}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"Sin", "[", "lambda", "]"}], 
               RowBox[{"Cos", "[", 
                RowBox[{"phi", "+", 
                 RowBox[{"Pi", "/", "2"}]}], "]"}]}], ",", 
              RowBox[{"Sin", "[", 
               RowBox[{"phi", "+", 
                RowBox[{"Pi", "/", "2"}]}], "]"}]}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"ay", "=", 
          RowBox[{"Simplify", "@", 
           RowBox[{"Cross", "[", 
            RowBox[{"az", ",", "ax"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"a", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "GM"}], "/", 
            RowBox[{"r", "^", "2"}]}], 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"j", "[", "n", "]"}], 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"R", "/", "r"}], ")"}], "^", "n"}], 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"n", "+", "1"}], ")"}], 
                 RowBox[{"LegendreP", "[", 
                  RowBox[{"n", ",", 
                   RowBox[{"Sin", "[", "phi", "]"}]}], "]"}]}], ",", "0", ",", 
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{"Cos", "[", "phi", "]"}]}], 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Derivative", "[", 
                    RowBox[{"0", ",", "1"}], "]"}], "[", "LegendreP", "]"}], 
                  "[", 
                  RowBox[{"n", ",", 
                   RowBox[{"Sin", "[", "phi", "]"}]}], "]"}]}]}], "}"}]}], 
             "\[IndentingNewLine]", "+", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"R", "/", "r"}], ")"}], "^", "n"}], " ", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"n", "+", "1"}], ")"}]}], 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", "m"}], " ", 
                   RowBox[{"LegendreP", "[", 
                    RowBox[{"n", ",", "m", ",", 
                    RowBox[{"Sin", "[", "phi", "]"}]}], "]"}], 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"+", 
                    RowBox[{"c", "[", 
                    RowBox[{"n", ",", "m"}], "]"}]}], 
                    RowBox[{"Cos", "[", 
                    RowBox[{"m", " ", "lambda"}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"s", "[", 
                    RowBox[{"n", ",", "m"}], "]"}], 
                    RowBox[{"Sin", "[", 
                    RowBox[{"m", " ", "lambda"}], "]"}]}]}], ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"m", " ", 
                   RowBox[{"Sec", "[", "phi", "]"}], 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", "m"}], " ", 
                   RowBox[{"LegendreP", "[", 
                    RowBox[{"n", ",", "m", ",", 
                    RowBox[{"Sin", "[", "phi", "]"}]}], "]"}], 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"c", "[", 
                    RowBox[{"n", ",", "m"}], "]"}]}], 
                    RowBox[{"Sin", "[", 
                    RowBox[{"m", " ", "lambda"}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"s", "[", 
                    RowBox[{"n", ",", "m"}], "]"}], 
                    RowBox[{"Cos", "[", 
                    RowBox[{"m", " ", "lambda"}], "]"}]}]}], ")"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Cos", "[", "phi", "]"}], 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", "m"}], " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Derivative", "[", 
                    RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", 
                    "LegendreP", "]"}], "[", 
                    RowBox[{"n", ",", "m", ",", 
                    RowBox[{"Sin", "[", "phi", "]"}]}], "]"}], 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"+", 
                    RowBox[{"c", "[", 
                    RowBox[{"n", ",", "m"}], "]"}]}], 
                    RowBox[{"Cos", "[", 
                    RowBox[{"m", " ", "lambda"}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"s", "[", 
                    RowBox[{"n", ",", "m"}], "]"}], 
                    RowBox[{"Sin", "[", 
                    RowBox[{"m", " ", "lambda"}], "]"}]}]}], ")"}]}]}], 
                 "\[IndentingNewLine]", "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", "1", ",", "n"}], "}"}]}], "]"}]}]}], 
            "\[IndentingNewLine]", ")"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"a", "=", 
          RowBox[{
           RowBox[{"Simplify", "[", 
            RowBox[{
             RowBox[{"TrigExpand", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"a", ".", 
                 RowBox[{"{", 
                  RowBox[{"ax", ",", "ay", ",", "az"}], "}"}]}], ")"}], "/.", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"r", "\[Rule]", 
                  RowBox[{"Sqrt", "[", 
                   RowBox[{
                    RowBox[{"x", "^", "2"}], "+", 
                    RowBox[{"y", "^", "2"}], "+", 
                    RowBox[{"z", "^", "2"}]}], "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"lambda", "\[Rule]", 
                  RowBox[{"ArcTan", "[", 
                   RowBox[{"x", ",", "y"}], "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"phi", "\[Rule]", 
                  RowBox[{"ArcTan", "[", 
                   RowBox[{
                    RowBox[{"Sqrt", "[", 
                    RowBox[{
                    RowBox[{"x", "^", "2"}], "+", 
                    RowBox[{"y", "^", "2"}]}], "]"}], ",", "z"}], "]"}]}]}], 
                "\[IndentingNewLine]", "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "^", "2"}], ">", "0"}], ",", 
               RowBox[{
                RowBox[{"y", "^", "2"}], ">", "0"}], ",", 
               RowBox[{
                RowBox[{"z", "^", "2"}], ">", "0"}]}], "}"}]}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{"GM", " ", 
             RowBox[{
              RowBox[{"R", "^", "n"}], "/", 
              RowBox[{
               RowBox[{"Sqrt", "[", 
                RowBox[{
                 RowBox[{"x", "^", "2"}], "+", 
                 RowBox[{"y", "^", "2"}], "+", 
                 RowBox[{"z", "^", "2"}]}], "]"}], "^", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "n"}], "+", "3"}], ")"}]}]}]}], ")"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Simplify", "@", 
          RowBox[{"Together", "@", 
           RowBox[{"Expand", "@", "a"}]}]}]}]}], "\[IndentingNewLine]", 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
   "(*", "\"\<\n\t\[CapitalDelta]\[Phi](n) \:4e3a\:884c\:661f\:7684 n \:9636\
\:7403\:8c10\:52bf\:573a\:ff0cM \:4e3a\:884c\:661f\:8d28\:91cf;\n\t\:6b64\
\:51fd\:6570\:8fd4\:56de\n\t\t\[CapitalDelta]\[Phi](n) / ( \!\(\*FractionBox[\
\(G\\\ M\\\ \*SuperscriptBox[\(R\), \(n\)]\), SuperscriptBox[\(r\), \(2 n + 1\
\)]]\) )\n\t\
\:8fd4\:56de\:503c\:4e2d\:7b26\:53f7\:542b\:4e49\:4e0e\:52a0\:901f\:5ea6\:8ba1\
\:7b97\:51fd\:6570\:76f8\:540c\:3002\[IndentingNewLine]\>\"", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"dphiH", "[", "n_", "]"}], ":=", 
     RowBox[{
      RowBox[{"dphiH", "[", "n", "]"}], "=", 
      RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Integrate", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"amH", "[", "n", "]"}], "/.", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x", "\[Rule]", 
                   RowBox[{"r", " ", "x"}]}], ",", 
                  RowBox[{"y", "\[Rule]", 
                   RowBox[{"r", " ", "y"}]}], ",", 
                  RowBox[{"z", "\[Rule]", 
                   RowBox[{"r", " ", "z"}]}]}], "}"}]}], ")"}], ".", 
              RowBox[{"{", " ", 
               RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "/", 
             RowBox[{"r", "^", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", "n"}], "+", "3"}], ")"}]}]}], ")"}], ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "1", ",", "Infinity"}], "}"}]}], "]"}]}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"x", "^", "2"}], "+", 
          RowBox[{"y", "^", "2"}], "+", 
          RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}]}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.867396388154011*^9, 3.8673967388629055`*^9}, {
   3.8673967953138027`*^9, 3.8673970503391867`*^9}, {3.867397405649438*^9, 
   3.8673974058681884`*^9}, 3.8673974596572*^9, {3.8673995619394407`*^9, 
   3.8673995888653507`*^9}},ExpressionUUID->"6fb4f37f-f223-4e57-a260-\
157394010366"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "\"\< \:793a\:4f8b\:ff1a\:8ba1\:7b97\:4e8c\:9636\:7403\:8c10\:5f15\
\:529b\:9879\:4e0e\:52bf\:573a \>\"", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"amH", "[", "2", "]"}], "\[IndentingNewLine]", 
   RowBox[{"dphiH", "[", "2", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8673971042177696`*^9, 3.867397105438577*^9}, {
  3.867397513254966*^9, 3.867397552392999*^9}, {3.867397898882202*^9, 
  3.8673979000794744`*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"185256a2-af4b-4077-9452-eab945a127b4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["3", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"6", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}], "+", 
         RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "+", 
      RowBox[{"x", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["y", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "14"}], " ", 
             RowBox[{"c", "[", 
              RowBox[{"2", ",", "2"}], "]"}]}], "+", 
            RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", ",", "2"}], "]"}], "+", 
            RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "+", 
         RowBox[{"10", " ", "y", " ", "z", " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"z", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "+", 
         RowBox[{"2", " ", "y", " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["y", "2"], "+", 
         SuperscriptBox["z", "2"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"z", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "+", 
         RowBox[{"2", " ", "y", " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["3", "2"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["y", "3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"6", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}], "-", 
         RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "+", 
      RowBox[{"4", " ", "y", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}], "+", 
         RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "-", 
      RowBox[{"8", " ", 
       SuperscriptBox["y", "2"], " ", "z", " ", 
       RowBox[{"s", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"s", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox["x", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"y", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"14", " ", 
             RowBox[{"c", "[", 
              RowBox[{"2", ",", "2"}], "]"}]}], "+", 
            RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "-", 
         RowBox[{"2", " ", "z", " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "3"], " ", 
       RowBox[{"s", "[", 
        RowBox[{"2", ",", "2"}], "]"}]}], "-", 
      RowBox[{"2", " ", "x", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"5", " ", "y", " ", "z", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "+", 
         RowBox[{"8", " ", 
          SuperscriptBox["y", "2"], " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["3", "2"]}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["x", "3"], " ", 
       RowBox[{"c", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       SuperscriptBox["y", "2"], " ", "z", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"10", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}], "-", 
         RowBox[{"3", " ", 
          RowBox[{"j", "[", "2", "]"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"j", "[", "2", "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["y", "3"], " ", 
       RowBox[{"s", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "-", 
      RowBox[{"8", " ", "y", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"s", "[", 
        RowBox[{"2", ",", "1"}], "]"}]}], "+", 
      RowBox[{
       SuperscriptBox["x", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "10"}], " ", "z", " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}], "-", 
         RowBox[{"3", " ", "z", " ", 
          RowBox[{"j", "[", "2", "]"}]}], "+", 
         RowBox[{"2", " ", "y", " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", "x", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["y", "2"], " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "-", 
         RowBox[{"4", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"c", "[", 
           RowBox[{"2", ",", "1"}], "]"}]}], "-", 
         RowBox[{"10", " ", "y", " ", "z", " ", 
          RowBox[{"s", "[", 
           RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.8673971077495203`*^9, 3.8673974299403176`*^9, 
  3.867397469231475*^9, 3.867397555643005*^9, 3.86739790076789*^9, 
  3.8673991558133073`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"7c1af5fc-f155-4769-a219-40c14e6266e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["y", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", ",", "2"}], "]"}]}], "-", 
     FractionBox[
      RowBox[{"j", "[", "2", "]"}], "2"]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"j", "[", "2", "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"6", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", ",", "2"}], "]"}]}], "+", 
     RowBox[{"j", "[", "2", "]"}]}], ")"}]}], "-", 
  RowBox[{"3", " ", "y", " ", "z", " ", 
   RowBox[{"s", "[", 
    RowBox[{"2", ",", "1"}], "]"}]}], "-", 
  RowBox[{"3", " ", "x", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"z", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", ",", "1"}], "]"}]}], "+", 
     RowBox[{"2", " ", "y", " ", 
      RowBox[{"s", "[", 
       RowBox[{"2", ",", "2"}], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.8673971077495203`*^9, 3.8673974299403176`*^9, 
  3.867397469231475*^9, 3.867397555643005*^9, 3.86739790076789*^9, 
  3.867399156851306*^9},
 CellLabel->"Out[4]=",ExpressionUUID->"c0477587-6a89-4b61-a317-ffe67da1b038"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "\"\< \:793a\:4f8b\:ff1a\:68c0\:9a8c \!\(\*SubscriptBox[\(\
\[CapitalDelta]\[Phi]\), \(2\)]\) = -\!\(\*FractionBox[\(\(G\)\(\\\ \)\(M\)\(\
\\\ \)\*SuperscriptBox[\(R\), \(2\)]\(\\\ \)\), SuperscriptBox[\(r\), \(5\)]]\
\)\!\(\*OverscriptBox[\(r\), \
\(\[RightVector]\)]\)\[CenterDot]\!\(\*SubscriptBox[\(H\), \
\(2\)]\)\!\(\*OverscriptBox[\(r\), \(\[RightVector]\)]\) \>\"", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"dphiH", "[", "2", "]"}], "-", 
    RowBox[{"(", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y", ",", "z"}], "}"}], ".", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{
          RowBox[{"(", GridBox[{
             {
              RowBox[{
               RowBox[{"j", "[", "2", "]"}], "+", 
               RowBox[{"6", 
                RowBox[{"c", "[", 
                 RowBox[{"2", ",", "2"}], "]"}]}]}], 
              RowBox[{"6", 
               RowBox[{"s", "[", 
                RowBox[{"2", ",", "2"}], "]"}]}], 
              RowBox[{"3", 
               RowBox[{"c", "[", 
                RowBox[{"2", ",", "1"}], "]"}]}]},
             {
              RowBox[{"6", 
               RowBox[{"s", "[", 
                RowBox[{"2", ",", "2"}], "]"}]}], 
              RowBox[{
               RowBox[{"j", "[", "2", "]"}], "-", 
               RowBox[{"6", 
                RowBox[{"c", "[", 
                 RowBox[{"2", ",", "2"}], "]"}]}]}], 
              RowBox[{"3", 
               RowBox[{"s", "[", 
                RowBox[{"2", ",", "1"}], "]"}]}]},
             {
              RowBox[{"3", 
               RowBox[{"c", "[", 
                RowBox[{"2", ",", "1"}], "]"}]}], 
              RowBox[{"3", 
               RowBox[{"s", "[", 
                RowBox[{"2", ",", "1"}], "]"}]}], 
              RowBox[{
               RowBox[{"-", "2"}], 
               RowBox[{"j", "[", "2", "]"}]}]}
            }], ")"}], ".", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y", ",", "z"}], "}"}]}]}], ")"}]}]}], ")"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.8673975622859526`*^9, 3.8673975995678825`*^9}, {
  3.8673976561437798`*^9, 3.8673978921871223`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"24bfd075-6ffd-4a04-b12b-485775795f78"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.867397694180208*^9, 3.867397742809698*^9}, {
   3.867397887094259*^9, 3.867397902048741*^9}, 3.867399159311088*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"b7e548ac-db84-4175-b5ae-4d0ab61c1c31"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "\"\< \:4ee5\:4e0b\:4ee3\:7801\:5c06\:7403\:8c10\:5f15\:529b\:4e0e\
\:52bf\:573a\:5c55\:5f00\:8ba1\:7b97\:5230 32 \:9636\:5e76\:5b58\:50a8\:3002\n\
    \:672c\:6587\:6863\:9644\:5e26\:5df2\:9884\:8ba1\:7b97\:5b8c\:6bd5\:7684\
\:76f4\:5230 32 \:9636\:7684\:5c55\:5f00\:7ed3\:679c\:ff0c\n    \:4e0d\:5efa\
\:8bae\:91cd\:65b0\:8fd0\:884c\:8fd9\:4e9b\:4ee3\:7801\:ff0c\:56e0\:4e3a\:8017\
\:65f6\:5b9e\:5728\:592a\:957f\:3002\>\"", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"FileExistsQ", "[", "\"\<GeopotentialExpression\>\"", "]"}]}], 
      ",", 
      RowBox[{
       RowBox[{
       "CreateDirectory", "[", "\"\<GeopotentialExpression\>\"", "]"}], 
       ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"ParallelMap", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Export", "[", 
        RowBox[{
         RowBox[{"\"\<GeopotentialExpression\\\\Gravity_Degree\>\"", "<>", 
          RowBox[{"IntegerString", "@", "#"}], "<>", "\"\<.txt\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ToString", "@", 
          RowBox[{"FullForm", "@", 
           RowBox[{"amH", "[", "#", "]"}]}]}], ",", "\"\<String\>\""}], "]"}],
        "&"}], ",", 
      RowBox[{"Range", "[", 
       RowBox[{"2", ",", "32"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"ParallelMap", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Export", "[", 
        RowBox[{
         RowBox[{"\"\<GeopotentialExpression\\\\Potential_Degree\>\"", "<>", 
          RowBox[{"IntegerString", "@", "#"}], "<>", "\"\<.txt\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ToString", "@", 
          RowBox[{"FullForm", "@", 
           RowBox[{"dphiH", "[", "#", "]"}]}]}], ",", "\"\<String\>\""}], 
        "]"}], "&"}], ",", 
      RowBox[{"Range", "[", 
       RowBox[{"2", ",", "32"}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", "*)"}]}]], "Input",
 CellChangeTimes->{{3.8673981018807096`*^9, 3.8673982262674265`*^9}, {
  3.867398257005763*^9, 3.8673982655505085`*^9}, {3.8673984125578685`*^9, 
  3.8673984699429436`*^9}, {3.8673989144410553`*^9, 3.867399032266449*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"78b2d38d-d3b8-493d-a154-ca3cc246a3ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "\"\< \:8fd9\:4e9b\:4ee3\:7801\:4ece\:9884\:8ba1\:7b97\:5230 32 \
\:9636\:7684\:5b58\:50a8\:6587\:4ef6\:4e2d\:52a0\:8f7d\:5c55\:5f00\:5f0f \
\>\"", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetDirectory", "[", 
     RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"amH", "[", "#", "]"}], "=", 
        RowBox[{"ToExpression", "@", 
         RowBox[{"Import", "[", 
          RowBox[{
           RowBox[{"\"\<GeopotentialExpression\\\\Gravity_Degree\>\"", "<>", 
            RowBox[{"IntegerString", "@", "#"}], "<>", "\"\<.txt\>\""}], ",", 
           "\"\<String\>\""}], "]"}]}]}], ")"}], "&"}], "/@", 
     RowBox[{"Range", "[", 
      RowBox[{"2", ",", "32"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"dphiH", "[", "#", "]"}], "=", 
        RowBox[{"ToExpression", "@", 
         RowBox[{"Import", "[", 
          RowBox[{
           RowBox[{"\"\<GeopotentialExpression\\\\Potential_Degree\>\"", "<>", 
            RowBox[{"IntegerString", "@", "#"}], "<>", "\"\<.txt\>\""}], ",", 
           "\"\<String\>\""}], "]"}]}]}], ")"}], "&"}], "/@", 
     RowBox[{"Range", "[", 
      RowBox[{"2", ",", "32"}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.867398535582342*^9, 3.8673986135433407`*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"2e0f76b9-b374-4aa5-8015-421a38673986"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "\"\< \:6d4b\:8bd5\:52bf\:573a\:662f\:5426\:662f\:5f15\:529b\:573a\
\:7684\:68af\:5ea6 \>\"", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"gradtestH", "[", "n_", "]"}], ":=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Grad", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"dphiH", "[", "n", "]"}], "/", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{
              RowBox[{"x", "^", "2"}], "+", 
              RowBox[{"y", "^", "2"}], "+", 
              RowBox[{"z", "^", "2"}]}], "]"}], "^", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "n"}], "+", "1"}], ")"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"x", "^", "2"}], "+", 
           RowBox[{"y", "^", "2"}], "+", 
           RowBox[{"z", "^", "2"}]}], "]"}], "^", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "n"}], "+", "3"}], ")"}]}]}], "-", 
       RowBox[{"amH", "[", "n", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
   "(*", "\"\< \:6d4b\:8bd5\:6ca1\:6709\:95ee\:9898\:3002\:4e0d\:8fc7\:8fd9\
\:4e5f\:9700\:8981\:82b1\:8d39\:8f83\:957f\:65f6\:95f4 \>\"", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"AbsoluteTiming", "[", 
    RowBox[{"gradtestH", "/@", 
     RowBox[{"Range", "[", 
      RowBox[{"2", ",", "32"}], "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.8673986530455265`*^9, 3.867398723108155*^9}, {
  3.8673990495972*^9, 3.867399085870946*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"82793653-a55e-4860-b86b-64512817b7f5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"513.7111778`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.8673996786522803`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"e6482497-0ac5-4aab-af88-9da6ffcfa260"]
}, Open  ]]
},
WindowSize->{1083, 564},
WindowMargins->{{Automatic, 53}, {Automatic, 202}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (2019\:5e744\:67088\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 12515, 290, 785, "Input",ExpressionUUID->"6fb4f37f-f223-4e57-a260-157394010366"],
Cell[CellGroupData[{
Cell[13098, 314, 547, 11, 67, "Input",ExpressionUUID->"185256a2-af4b-4077-9452-eab945a127b4"],
Cell[13648, 327, 6114, 181, 197, "Output",ExpressionUUID->"7c1af5fc-f155-4769-a219-40c14e6266e1"],
Cell[19765, 510, 1242, 38, 50, "Output",ExpressionUUID->"c0477587-6a89-4b61-a317-ffe67da1b038"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21044, 553, 2353, 63, 96, "Input",ExpressionUUID->"24bfd075-6ffd-4a04-b12b-485775795f78"],
Cell[23400, 618, 244, 3, 32, "Output",ExpressionUUID->"b7e548ac-db84-4175-b5ae-4d0ab61c1c31"]
}, Open  ]],
Cell[23659, 624, 2503, 55, 257, "Input",ExpressionUUID->"78b2d38d-d3b8-493d-a154-ca3cc246a3ed"],
Cell[26165, 681, 1569, 40, 86, "Input",ExpressionUUID->"2e0f76b9-b374-4aa5-8015-421a38673986"],
Cell[CellGroupData[{
Cell[27759, 725, 1790, 48, 86, "Input",ExpressionUUID->"82793653-a55e-4860-b86b-64512817b7f5"],
Cell[29552, 775, 2499, 68, 71, "Output",ExpressionUUID->"e6482497-0ac5-4aab-af88-9da6ffcfa260"]
}, Open  ]]
}
]
*)

